/***********************************************************************************
 * ICTCLAS飺ʷϵͳICTCLAS
 *              Institute of Computing Technology, Chinese Lexical Analysis System
 *              УķִʣԱעδ¼ʶ
 *              ִȷʸߴ97.58%(973ר)
 *              δ¼ʶٻʾ90%йʶٻʽӽ98%;
 *              ٶΪ31.5Kbytes/s
 * Ȩ  Copyright(c)2002-2005пԺ ְȨˣŻƽ
 * ѭЭ飺ȻԴԴ֤1.0
 * Email: zhanghp@software.ict.ac.cn
 * Homepage:www.i3s.ac.cn
 * 
 *----------------------------------------------------------------------------------
 * 
 * Copyright (c) 2000, 2001
 *     Institute of Computing Tech.
 *     Chinese Academy of Sciences
 *     All rights reserved.
 *
 * This file is the confidential and proprietary property of
 * Institute of Computing Tech. and the posession or use of this file requires
 * a written license from the author.
 * Author:   Kevin Zhang
 *          (zhanghp@software.ict.ac.cn)
 * 
 *----------------------------------------------------------------------------------
 * 
 * SharpICTCLAS.netƽ̨µICTCLAS
 *               ɺӱѧѧԺFreeICTCLASıɣ
 *               ԭд˲д
 * 
 * Email: zhenyulu@163.com
 * Blog: http://www.cnblogs.com/zhenyulu
 * 
 ***********************************************************************************/
using System;
using System.Text;
using System.Collections.Generic;

namespace SharpICTCLAS
{
    [Serializable]
    public abstract class DynamicArray<T>
    {
        protected ChainItem<T> pHead;  //The head pointer of array chain
        public int ColumnCount, RowCount;  //The row and col of the array

        #region Constructor

        public DynamicArray()
        {
            pHead = null;
            RowCount = 0;
            ColumnCount = 0;
        }

        #endregion

        #region ItemCount Property

        public int ItemCount
        {
            get
            {
                ChainItem<T> pCur = pHead;
                int nCount = 0;
                while (pCur != null)
                {
                    nCount++;
                    pCur = pCur.next;
                }
                return nCount;
            }
        }

        #endregion

        #region GetElement Method

        //====================================================================
        // СֵΪnRow, nColĽ
        //====================================================================
        public ChainItem<T> GetElement(int nRow, int nCol)
        {
            ChainItem<T> pCur = pHead;

            while (pCur != null && !(pCur.col == nCol && pCur.row == nRow))
                pCur = pCur.next;

            return pCur;
        }

        #endregion

        #region SetElement Method

        //====================================================================
        // ûһµĽ
        //====================================================================
        public abstract void SetElement(int nRow, int nCol, T content);

        #endregion

        #region GetHead, GetTail, SetEmpty Method

        //====================================================================
        // Return the head element of ArrayChain
        //====================================================================
        public ChainItem<T> GetHead()
        {
            return pHead;
        }

        //====================================================================
        //Get the tail Element buffer and return the count of elements
        //====================================================================
        public int GetTail(out ChainItem<T> pTailRet)
        {
            ChainItem<T> pCur = pHead, pPrev = null;
            int nCount = 0;
            while (pCur != null)
            {
                nCount++;
                pPrev = pCur;
                pCur = pCur.next;
            }
            pTailRet = pPrev;
            return nCount;
        }

        //====================================================================
        // Set Empty
        //====================================================================
        public void SetEmpty()
        {
            pHead = null;
            ColumnCount = 0;
            RowCount = 0;
        }

        #endregion

        #region ToString Method

        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();

            ChainItem<T> pCur = pHead;

            while (pCur != null)
            {
                sb.Append(string.Format("row:{0,3},  col:{1,3},  ", pCur.row, pCur.col));
                sb.Append(pCur.Content.ToString());
                sb.Append("\r\n");
                pCur = pCur.next;
            }

            return sb.ToString();
        }

        #endregion

        #region

        public List<ChainItem<T>> ToListItems()
        {
            List<ChainItem<T>> result = new List<ChainItem<T>>();

            ChainItem<T> pCur = pHead;
            while (pCur != null)
            {
                result.Add(pCur);
                pCur = pCur.next;
            }

            return result;
        }

        #endregion
    }
}
