/***********************************************************************************
 * ICTCLAS飺ʷϵͳICTCLAS
 *              Institute of Computing Technology, Chinese Lexical Analysis System
 *              УķִʣԱעδ¼ʶ
 *              ִȷʸߴ97.58%(973ר)
 *              δ¼ʶٻʾ90%йʶٻʽӽ98%;
 *              ٶΪ31.5Kbytes/s
 * Ȩ  Copyright(c)2002-2005пԺ ְȨˣŻƽ
 * ѭЭ飺ȻԴԴ֤1.0
 * Email: zhanghp@software.ict.ac.cn
 * Homepage:www.i3s.ac.cn
 * 
 *----------------------------------------------------------------------------------
 * 
 * Copyright (c) 2000, 2001
 *     Institute of Computing Tech.
 *     Chinese Academy of Sciences
 *     All rights reserved.
 *
 * This file is the confidential and proprietary property of
 * Institute of Computing Tech. and the posession or use of this file requires
 * a written license from the author.
 * Author:   Kevin Zhang
 *          (zhanghp@software.ict.ac.cn)
 * 
 *----------------------------------------------------------------------------------
 * 
 * SharpICTCLAS.netƽ̨µICTCLAS
 *               ɺӱѧѧԺFreeICTCLASıɣ
 *               ԭд˲д
 * 
 * Email: zhenyulu@163.com
 * Blog: http://www.cnblogs.com/zhenyulu
 * 
 ***********************************************************************************/
using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.Text;

namespace SharpICTCLAS
{
    [Serializable]
    public class NShortPath
    {
        private static ColumnFirstDynamicArray<ChainContent> m_apCost;
        private static int m_nValueKind; //The number of value kinds
        private static int m_nNode; //The number of Node in the graph
        private static CQueue[][] m_pParent; //The 2-dimension array for the nodes
        private static double[][] m_pWeight; //The weight of node

        #region 캯

        private NShortPath()
        {
        }

        #endregion

        #region InitNShortPath Method

        private static void InitNShortPath(ColumnFirstDynamicArray<ChainContent> apCost, int nValueKind)
        {
            m_apCost = apCost; //Set the cost
            m_nValueKind = nValueKind; //Set the value kind

            // ȡĿ
            // ----------------- עby zhenyulu ------------------
            // ԭΪm_nNode = Math.Max(apCost.ColumnCount, apCost.RowCount) + 1;
            // apCost.ColumnCountӦһapCost.RowCountԸĳ
            m_nNode = apCost.ColumnCount + 1;

            m_pParent = new CQueue[m_nNode - 1][]; //not including the first node
            m_pWeight = new double[m_nNode - 1][];

            //The queue array for every node
            for (int i = 0; i < m_nNode - 1; i++)
            {
                m_pParent[i] = new CQueue[nValueKind];
                m_pWeight[i] = new double[nValueKind];

                for (int j = 0; j < nValueKind; j++)
                    m_pParent[i][j] = new CQueue();
            }
        }

        #endregion

        #region Calculate Method

        //====================================================================
        // нϿܵ·Ϊ·ṩ׼
        //====================================================================
        public static void Calculate(ColumnFirstDynamicArray<ChainContent> apCost, int nValueKind)
        {
            InitNShortPath(apCost, nValueKind);

            QueueElement tmpElement;
            CQueue queWork = new CQueue();
            double eWeight;

            for (int nCurNode = 1; nCurNode < m_nNode; nCurNode++)
            {
                // еǰ㣨nCurNode)ܵı߸eWeightѹ
                EnQueueCurNodeEdges(ref queWork, nCurNode);

                // ʼǰбߵeWeightֵ
                for (int i = 0; i < m_nValueKind; i++)
                    m_pWeight[nCurNode - 1][i] = Predefine.INFINITE_VALUE;

                // queWorkеװm_pWeightm_pParent
                tmpElement = queWork.DeQueue();
                if (tmpElement != null)
                {
                    for (int i = 0; i < m_nValueKind; i++)
                    {
                        eWeight = tmpElement.eWeight;
                        m_pWeight[nCurNode - 1][i] = eWeight;
                        do
                        {
                            m_pParent[nCurNode - 1][i].EnQueue(new QueueElement(tmpElement.nParent, tmpElement.nIndex, 0));
                            tmpElement = queWork.DeQueue();
                            if (tmpElement == null)
                                goto nextnode;

                        } while (tmpElement.eWeight == eWeight);
                    }
                }
            nextnode: ;
            }
        }

        //====================================================================
        // еǰ㣨nCurNodeܵı߸eWeightѹ
        //====================================================================
        private static void EnQueueCurNodeEdges(ref CQueue queWork, int nCurNode)
        {
            int nPreNode;
            double eWeight;
            ChainItem<ChainContent> pEdgeList;

            queWork.Clear();
            pEdgeList = m_apCost.GetFirstElementOfCol(nCurNode);

            // Get all the edges
            while (pEdgeList != null && pEdgeList.col == nCurNode)
            {
                nPreNode = pEdgeList.row;  // رrowcolĹϵ
                eWeight = pEdgeList.Content.eWeight; //Get the eWeight of edges

                for (int i = 0; i < m_nValueKind; i++)
                {
                    // һ㣬ûPreNodeֱӼ
                    if (nPreNode == 0)
                    {
                        queWork.EnQueue(new QueueElement(nPreNode, i, eWeight));
                        break;
                    }

                    // PreNodeWeight == Predefine.INFINITE_VALUEûбҪȥ
                    if (m_pWeight[nPreNode - 1][i] == Predefine.INFINITE_VALUE)
                        break;

                    queWork.EnQueue(new QueueElement(nPreNode, i, eWeight + m_pWeight[nPreNode - 1][i]));
                }
                pEdgeList = pEdgeList.next;
            }
        }

        #endregion

        #region GetPaths Method

        //====================================================================
        // עindex  0 : ̵· index = 1  ζ̵·
        //     ơindex <= this.m_nValueKind
        //====================================================================
        public static List<int[]> GetPaths(int index)
        {
            Debug.Assert(index <= m_nValueKind && index >= 0);

            Stack<PathNode> stack = new Stack<PathNode>();
            int curNode = m_nNode - 1, curIndex = index;
            QueueElement element;
            PathNode node;
            int[] aPath;
            List<int[]> result = new List<int[]>();

            element = m_pParent[curNode - 1][curIndex].GetFirst();
            while (element != null)
            {
                // ---------- ͨѹջõ· -----------
                stack.Push(new PathNode(curNode, curIndex));
                stack.Push(new PathNode(element.nParent, element.nIndex));
                curNode = element.nParent;

                while (curNode != 0)
                {
                    element = m_pParent[element.nParent - 1][element.nIndex].GetFirst();
                    stack.Push(new PathNode(element.nParent, element.nIndex));
                    curNode = element.nParent;
                }

                // -------------- · --------------
                PathNode[] nArray = stack.ToArray();
                aPath = new int[nArray.Length];

                for (int i = 0; i < aPath.Length; i++)
                    aPath[i] = nArray[i].nParent;

                result.Add(aPath);

                // -------------- ջԼǷ· --------------
                do
                {
                    node = stack.Pop();
                    curNode = node.nParent;
                    curIndex = node.nIndex;

                } while (curNode < 1 || (stack.Count != 0 && !m_pParent[curNode - 1][curIndex].CanGetNext));

                element = m_pParent[curNode - 1][curIndex].GetNext();
            }

            return result;
        }

        #endregion

        #region GetBestPath Method

        //====================================================================
        // ȡΨһһ·Ȼ·ֻܲһ
        //====================================================================
        public static int[] GetBestPath()
        {
            Debug.Assert(m_nNode > 2);

            Stack<int> stack = new Stack<int>();
            int curNode = m_nNode - 1, curIndex = 0;
            QueueElement element;

            element = m_pParent[curNode - 1][curIndex].GetFirst();

            stack.Push(curNode);
            stack.Push(element.nParent);
            curNode = element.nParent;

            while (curNode != 0)
            {
                element = m_pParent[element.nParent - 1][element.nIndex].GetFirst();
                stack.Push(element.nParent);
                curNode = element.nParent;
            }

            return stack.ToArray();
        }

        #endregion

        #region GetNPaths Method

        //====================================================================
        // Ӷ̵ȡ n ·
        //====================================================================
        public static List<int[]> GetNPaths(int n)
        {
            List<int[]> result = new List<int[]>();
            List<int[]> tmp;
            int nCopy;

            for (int i = 0; i < m_nValueKind && result.Count < Predefine.MAX_SEGMENT_NUM; i++)
            {
                tmp = GetPaths(i);

                if (n - result.Count < tmp.Count)
                    nCopy = n - result.Count;
                else
                    nCopy = tmp.Count;

                for (int j = 0; j < nCopy; j++)
                    result.Add(tmp[j]);
            }

            return result;
        }

        #endregion

        #region мĲԴ

        public static void printResultByIndex()
        {
            QueueElement e;

            for (int i = 0; i < m_nValueKind; i++)
            {
                Console.WriteLine("\n\r============ Index = {0} ============", i);
                for (int nCurNode = 1; nCurNode < m_nNode; nCurNode++)
                {
                    Console.WriteLine("Node Num: {0}", nCurNode);

                    e = m_pParent[nCurNode - 1][i].GetFirst();
                    while (e != null)
                    {
                        Console.WriteLine("({0}, {1})  eWeight = {2}", e.nParent, e.nIndex, m_pWeight[nCurNode - 1][i]);
                        e = m_pParent[nCurNode - 1][i].GetNext();
                    }
                    Console.WriteLine("---------------------");
                }
            }
        }

        public static void printResultByNode()
        {
            QueueElement e;

            for (int nCurNode = 1; nCurNode < m_nNode; nCurNode++)
            {
                Console.WriteLine("\n\r============  {0}  ============", nCurNode);
                for (int i = 0; i < m_nValueKind; i++)
                {
                    Console.WriteLine("N: {0}", i);

                    e = m_pParent[nCurNode - 1][i].GetFirst();
                    while (e != null)
                    {
                        Console.WriteLine("({0}, {1})  eWeight = {2}", e.nParent, e.nIndex, m_pWeight[nCurNode - 1][i]);
                        e = m_pParent[nCurNode - 1][i].GetNext();
                    }
                    Console.WriteLine("---------------------");
                }
            }
        }

        #endregion

    }
}
