/***********************************************************************************
 * ICTCLAS飺ʷϵͳICTCLAS
 *              Institute of Computing Technology, Chinese Lexical Analysis System
 *              УķִʣԱעδ¼ʶ
 *              ִȷʸߴ97.58%(973ר)
 *              δ¼ʶٻʾ90%йʶٻʽӽ98%;
 *              ٶΪ31.5Kbytes/s
 * Ȩ  Copyright(c)2002-2005пԺ ְȨˣŻƽ
 * ѭЭ飺ȻԴԴ֤1.0
 * Email: zhanghp@software.ict.ac.cn
 * Homepage:www.i3s.ac.cn
 * 
 *----------------------------------------------------------------------------------
 * 
 * Copyright (c) 2000, 2001
 *     Institute of Computing Tech.
 *     Chinese Academy of Sciences
 *     All rights reserved.
 *
 * This file is the confidential and proprietary property of
 * Institute of Computing Tech. and the posession or use of this file requires
 * a written license from the author.
 * Author:   Kevin Zhang
 *          (zhanghp@software.ict.ac.cn)
 * 
 *----------------------------------------------------------------------------------
 * 
 * SharpICTCLAS.netƽ̨µICTCLAS
 *               ɺӱѧѧԺFreeICTCLASıɣ
 *               ԭд˲д
 * 
 * Email: zhenyulu@163.com
 * Blog: http://www.cnblogs.com/zhenyulu
 * 
 ***********************************************************************************/
using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Text.RegularExpressions;

namespace SharpICTCLAS
{
    [Serializable]
    public sealed class Utility
    {
        private Utility()
        {
        }

        #region GetPOSValue Method

        public static int GetPOSValue(string sPOS)
        {
            char[] c = sPOS.ToCharArray();

            if (c.Length == 1)
                return Convert.ToInt32(c[0]) * 256;
            else if (c.Length == 2)
                return Convert.ToInt32(c[0]) * 256 + Convert.ToInt32(c[1]);
            else
            {
                string s1 = sPOS.Substring(0, sPOS.IndexOf('+'));
                string s2 = sPOS.Substring(sPOS.IndexOf('+') + 1);
                return 100 * GetPOSValue(s1) + Int32.Parse(s2);
            }
        }

        #endregion

        #region GetPOSString Method

        public static string GetPOSString(int nPOS)
        {
            string sPOSRet;
            char c = Convert.ToChar(nPOS % 256);
            string cstr = (c == '\0' ? string.Empty : c.ToString());

            if (nPOS > Convert.ToInt32('a') * 25600)
            {
                if ((nPOS / 100) % 256 != 0)
                    sPOSRet = string.Format("{0}{1}+{2}", Convert.ToChar(nPOS / 25600), Convert.ToChar((nPOS / 100) % 256), cstr);
                else
                    sPOSRet = string.Format("{0}+{1}", Convert.ToChar(nPOS / 25600), cstr);
            }
            else
            {

                if (nPOS > 256)
                    sPOSRet = string.Format("{0}{1}", Convert.ToChar(nPOS / 256), cstr);
                else
                    sPOSRet = string.Format("{0}", cstr);
            }
            return sPOSRet;
        }

        #endregion

        //====================================================================
        // ݺֵֽڷضӦCC_ID
        //====================================================================
        public static int CC_ID(byte b1, byte b2)
        {
            return (Convert.ToInt32(b1) - 176) * 94 + (Convert.ToInt32(b2) - 161);
        }

        //====================================================================
        // ݺַضӦCC_ID
        //====================================================================
        public static int CC_ID(char c)
        {
            byte[] b = Encoding.GetEncoding("gb2312").GetBytes(c.ToString());
            if (b.Length != 2)
                return -1;
            else
                return (Convert.ToInt32(b[0]) - 176) * 94 + (Convert.ToInt32(b[1]) - 161);
        }

        //====================================================================
        // CC_IDضӦĺ
        //====================================================================
        public static char CC_ID2Char(int cc_id)
        {
            if (cc_id < 0 || cc_id > Predefine.CC_NUM)
                return '\0';

            byte[] b = new byte[2];

            b[0] = CC_CHAR1(cc_id);
            b[1] = CC_CHAR2(cc_id);
            return (Encoding.GetEncoding("gb2312").GetChars(b))[0];
        }

        //====================================================================
        // CC_IDضӦֵĵһֽ
        //====================================================================
        public static byte CC_CHAR1(int cc_id)
        {
            return Convert.ToByte(cc_id / 94 + 176);
        }

        //====================================================================
        // CC_IDضӦֵĵڶֽ
        //====================================================================
        public static byte CC_CHAR2(int cc_id)
        {
            return Convert.ToByte(cc_id % 94 + 161);
        }

        //====================================================================
        // ַתΪֽ飨ڽҪֳ2ֽڣ
        //====================================================================
        public static byte[] String2ByteArray(string s)
        {
            return Encoding.GetEncoding("gb2312").GetBytes(s);
        }

        //====================================================================
        // ֽתΪַ
        //====================================================================
        public static string ByteArray2String(byte[] byteArray)
        {
            return Encoding.GetEncoding("gb2312").GetString(byteArray);
        }

        //====================================================================
        // ȡַȣһְ2㣩
        //====================================================================
        public static int GetWordLength(string s)
        {
            return String2ByteArray(s).Length;
        }

        //====================================================================
        // Func Name  : charType
        // Description: Judge the type of sChar or (sChar,sChar+1)
        // Parameters : sFilename: the file name for the output CC List
        // Returns    : int : the type of char
        //====================================================================
        public static int charType(char c)
        {
            if (Convert.ToInt32(c) < 128)
            {
                string delimiters = "*!,.?()[]{}+=";
                //עͣԭΪ"\042!,.?()[]{}+=""\042"Ϊ1042ASCַΪ*
                if (delimiters.IndexOf(c) >= 0)
                    return Predefine.CT_DELIMITER;
                return Predefine.CT_SINGLE;
            }

            byte[] byteArray = Encoding.GetEncoding("gb2312").GetBytes(c.ToString());

            if (byteArray.Length != 2)
                return Predefine.CT_OTHER;

            int b1 = Convert.ToInt32(byteArray[0]);
            int b2 = Convert.ToInt32(byteArray[1]);

            return DoubleByteCharType(b1, b2);
        }

        private static int DoubleByteCharType(int b1, int b2)
        {
            //-------------------------------------------------------
            /*
               code  +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F
               A2A0                   
               A2B0                 
               A2C0                 
               A2D0                 
               A2E0                 
               A2F0                   
             */
            if (b1 == 162)
                return Predefine.CT_INDEX;

            //-------------------------------------------------------
            //         
            else if (b1 == 163 && b2 > 175 && b2 < 186)
                return Predefine.CT_NUM;

            //-------------------------------------------------------
            //£ãģţƣǣȣɣʣˣ̣ͣΣϣУѣңӣԣգ֣ףأ٣
            // 
            else if (b1 == 163 && (b2 >= 193 && b2 <= 218 || b2 >= 225 && b2 <= 250))
                return Predefine.CT_LETTER;

            //-------------------------------------------------------
            /*
              code  +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F
              A1A0                   
              A1B0                 
              A1C0                 
              A1D0                 
              A1E0                 
              A1F0                   
              ³ĸֵĲ
              code  +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F
              A3A0                   
              A3B0                                     
              A3C0   
              A3D0                                       
              A3E0   
              A3F0                                       
             */
            else if (b1 == 161 || b1 == 163)
                return Predefine.CT_DELIMITER;


            else if (b1 >= 176 && b1 <= 247)
                return Predefine.CT_CHINESE;


            else
                return Predefine.CT_OTHER;
        }

        //====================================================================
        // Func Name  : IsAllSingleByte
        // Description: Judge the string is all made up of Single Byte Char
        // Parameters : sSentence: the original sentence which includes Chinese or Non-Chinese char
        // Returns    : the end of the sub-sentence
        //====================================================================
        public static bool IsAllChinese(string sString)
        {
            byte[] byteArray = String2ByteArray(sString);

            int nLen = byteArray.Length, i = 0;

            while (i < nLen - 1 && Convert.ToInt32(byteArray[i]) < 248 && Convert.ToInt32(byteArray[i]) > 175)
            {
                i += 2;
            }
            if (i < nLen)
                return false;
            return true;
        }

        //====================================================================
        //Judge the string is all made up of Num Char
        //====================================================================
        public static bool IsAllNum(string sString)
        {
            return Regex.IsMatch(sString, @"^[+\-]?[\d]*[á./]?[\d]*[ǧڰǪ%]?$");
        }

        //====================================================================
        //Decide whether the word is Chinese Num word
        //====================================================================
        public static bool IsAllChineseNum(string sWord)
        {
            //ٷ֮ϰ˵ʮ˷
            return Regex.IsMatch(sWord, @"^[ϳ]?[һ߰˾ʮإǧҼ½ƾʰǪá]*[֮]?[һ߰˾ʮإǧҼ½ƾʰǪ]*$");
        }

        //====================================================================
        //Binary search a value in a table which len is nTableLen
        //====================================================================
        public static int BinarySearch(int nVal, int[] nTable)
        {
            int nStart = 0, nEnd = nTable.Length - 1, nMid = (nStart + nEnd) / 2;

            while (nStart <= nEnd)
            {
                if (nTable[nMid] == nVal)
                    return nMid;
                else if (nTable[nMid] < nVal)
                    nStart = nMid + 1;
                else
                    nEnd = nMid - 1;
                nMid = (nStart + nEnd) / 2;
            }

            return -1;
        }

        //====================================================================
        //Judge the string is all made up of Letter Char
        //====================================================================
        public static bool IsAllLetter(string sString)
        {
            char[] charArray = sString.ToCharArray();
            foreach (char c in charArray)
                if (charType(c) != Predefine.CT_LETTER)
                    return false;

            return true;
        }

        //====================================================================
        //Decide whether the word is all  non-foreign translation
        //====================================================================
        public static int GetForeignCharCount(string sWord)
        {
            int nForeignCount, nCount;
            nForeignCount = GetCharCount(Predefine.TRANS_ENGLISH, sWord); //English char counnts
            nCount = GetCharCount(Predefine.TRANS_JAPANESE, sWord); //Japan char counnts
            if (nForeignCount <= nCount)
                nForeignCount = nCount;
            nCount = GetCharCount(Predefine.TRANS_RUSSIAN, sWord); //Russian char counnts
            if (nForeignCount <= nCount)
                nForeignCount = nCount;
            return nForeignCount;
        }

        //====================================================================
        //Get the count of char which is in sWord and in sCharSet
        //====================================================================
        public static int GetCharCount(string sCharSet, string sWord)
        {
            int nCount = 0;
            char[] charArray = sWord.ToCharArray();
            foreach (char c in charArray)
                if (sCharSet.IndexOf(c) != -1)
                    nCount++;

            return nCount;
        }

        //====================================================================
        // CC_IDĴСȽַ  <  < ֡
        //====================================================================
        public static int CCStringCompare(string str1, string str2)
        {
            char[] ca1 = str1.ToCharArray();
            char[] ca2 = str2.ToCharArray();

            int minLength = Math.Min(ca1.Length, ca2.Length);

            for (int i = 0; i < minLength; i++)
            {
                if (Convert.ToInt32(ca1[i]) < 128 && Convert.ToInt32(ca2[i]) < 128) //ַǰ
                {
                    if (ca1[i] < ca2[i])
                        return -1;
                    else if (ca1[i] > ca2[i])
                        return 1;
                }
                else if (Convert.ToInt32(ca1[i]) < 128)
                    return -1;
                else if (Convert.ToInt32(ca2[i]) < 128)
                    return 1;
                else //ַȫȫ
                {
                    if (CC_ID(ca1[i]) < CC_ID(ca2[i]))
                        return -1;
                    if (CC_ID(ca1[i]) > CC_ID(ca2[i]))
                        return 1;
                }
            }

            if (ca1.Length > ca2.Length)
                return 1;
            else if (ca1.Length == ca2.Length)
                return 0;
            else
                return -1;
        }

        //====================================================================
        //Generate the GB2312 List file
        //====================================================================
        public static bool GB2312_Generate(string sFileName)
        {
            bool isSuccess = true;
            byte[] b = new byte[2];
            FileStream outputFile = null;
            StreamWriter writer = null;

            try
            {
                outputFile = new FileStream(sFileName, FileMode.Create, FileAccess.Write);
                if (outputFile == null)
                    return false;

                writer = new StreamWriter(outputFile, Encoding.GetEncoding("gb2312"));

                for (int i = 161; i < 255; i++)
                    for (int j = 161; j < 255; j++)
                    {
                        b[0] = Convert.ToByte(i);
                        b[1] = Convert.ToByte(j);
                        writer.WriteLine(string.Format("{0}, {1}, {2}", ByteArray2String(b), i, j));
                    }
            }
            catch
            {
                isSuccess = false;
            }
            finally
            {
                if (writer != null)
                    writer.Close();

                if (outputFile != null)
                    outputFile.Close();
            }
            return isSuccess;
        }

        //====================================================================
        //Generate the Chinese Char List file
        //====================================================================
        public static bool CC_Generate(string sFileName)
        {
            bool isSuccess = true;
            byte[] b = new byte[2];
            FileStream outputFile = null;
            StreamWriter writer = null;

            try
            {
                outputFile = new FileStream(sFileName, FileMode.Create, FileAccess.Write);
                if (outputFile == null)
                    return false;

                writer = new StreamWriter(outputFile, Encoding.GetEncoding("gb2312"));

                for (int i = 176; i < 255; i++)
                    for (int j = 161; j < 255; j++)
                    {
                        b[0] = Convert.ToByte(i);
                        b[1] = Convert.ToByte(j);
                        writer.WriteLine(string.Format("{0}, {1}, {2}", ByteArray2String(b), i, j));
                    }
            }
            catch
            {
                isSuccess = false;
            }
            finally
            {
                if (writer != null)
                    writer.Close();

                if (outputFile != null)
                    outputFile.Close();
            }
            return isSuccess;
        }

        #region ȫǰת

        /*==========================================
       * 
       * Author : ΰ(kwklover)
       * Home   : http://www.cnblogs.com/kwklover
       *==========================================*/
        /// <summary>
        /// ַתΪȫǵ(תȫ)
        /// </summary>
        /// <param name="c"></param>
        /// <returns></returns>
        public static char ConvertToQJC(char c)
        {
            if (c == 32)
                return (char)12288;

            if (c < 127)
                return (char)(c + 65248);

            return c;
        }

        /// <summary>
        /// ַתΪǵ(ȫת)
        /// </summary>
        /// <param name="c"></param>
        /// <returns></returns>
        public static char ConvertToBJC(char c)
        {
            if (c == 12288)
                return (char)32;

            if (c > 65280 && c < 65375)
                return (char)(c - 65248);

            return c;
        }

        /*=============================================================================
         *from http://hardrock.cnblogs.com/archive/2005/09/27/245255.html
         ==============================================================================*/
        /// <summary>
        /// תȫǵĺ(SBC case)
        /// </summary>
        /// <param name="input">ַ</param>
        /// <returns>ȫַ</returns>
        ///<remarks>
        ///ȫǿոΪ12288ǿոΪ32
        ///ַ(33-126)ȫ(65281-65374)ĶӦϵǣ65248
        ///</remarks>        
        public static string ToSBC(string input)
        {
            //תȫǣ
            char[] c = input.ToCharArray();
            for (int i = 0; i < c.Length; i++)
            {
                if (c[i] == 32)
                {
                    c[i] = (char)12288;
                    continue;
                }
                if (c[i] < 127)
                    c[i] = (char)(c[i] + 65248);
            }
            return new string(c);
        }


        /// <summary>
        /// תǵĺ(DBC case)
        /// </summary>
        /// <param name="input">ַ</param>
        /// <returns>ַ</returns>
        ///<remarks>
        ///ȫǿոΪ12288ǿոΪ32
        ///ַ(33-126)ȫ(65281-65374)ĶӦϵǣ65248
        ///</remarks>
        public static string ToDBC(string input)
        {
            char[] c = input.ToCharArray();
            for (int i = 0; i < c.Length; i++)
            {
                if (c[i] == 12288)
                {
                    c[i] = (char)32;
                    continue;
                }
                if (c[i] > 65280 && c[i] < 65375)
                    c[i] = (char)(c[i] - 65248);
            }
            return new string(c);
        }

        #endregion

        public static string Traditional2Simplified(string s)
        {
            StringBuilder sb = new StringBuilder();

            string simp = "ﹰưӰٰڰ°ӰＱʱϱбұϱֱ߱ޱ𾲹߲ƲβϲвѲҲԲղֲײ޲٭βⳡ𳮳³ųƳͳϳճٳ۳ܳݳ拾ٱųۻ鴫˴봸綴ȴǴʴ˴ϴдѴӴȴꣴڴߥ窵쵱ɵƵеӵݵڮߵ񼶿ĶͶ϶ҶӶֶٶܷ÷зɷ̷Ϸ׷طܷ߷ǷŸøƸ˸ϸѸߦ礸ԸոָٸغھﯸبṨڸƹڬйع۹ݹ߹ڴҺ׺ڭúڧݦ׺ɻۼƻӻԻٻ߻ڶͻڻԻüƼǼʼ̼ڦڵߴмԼռּؼۼۣͼ߼ֽ½ýĽŽȽɽʽν޽׽ڽڽݣǾվԾپݾڪ俪ſǿѿ﬿ٿ෿ۦڿſڲڿܿڳٳ۪ݰ߿¢£¤¥¦§¨«¬­®¯°±²³¸»¼½ߣ¿߼۽áèêíóûþıĶګšŢťŦŧŨũٯŵűŷŸŹŻŽکƭƮƵƶƻƾޭǣǥǦǨǩǫǮǯǱǳǴǵݡǹǺǽǾǿڽȣڰȧȨȰڹȴȵȷɡɥɧɨɬɱɲɴɸɹɾڨڷʤʦʨʪʫʱʴʵʶʻݪ߱˧˫˭˰˳˵˶˸˿޴ݥ̷̸̡̢̨̬̯̰̱̲̳̾ͭͳͷͺͼΤΥΧΪΫάέΰαγνݫϮϰϳϷϸϺϽϿݲ޺ܼХЭЮЯвгдклߢпڼѡѢѤѧѫѯѰѱѵѶѷѹѻѼٲҡҢңҤҥҩүҳҵҶҽҿڱ߽ӣӤӥӦӧӨөӪӫӬӮӱݺӴӵӶӸӻӽݵԤԦٶԧԨԯ԰ԱԲԵԶԼԾԿ۩ܿաբդթիծձյնշոջսگ֢֣֤֡ںְִֽֿ֯פרשת׬׮ׯװױ׳״׶׸׹׺׻׼ɸ޹սܾôùǤʥʬ̧ͿιЫӿԸ־עڥۧݤݧݯݻ޻߸";
            string trad = "H}@Kۇܭa\O@ga\WTZ[hCkOkͽ^rUd_݅ؐ^NvlSQP]ɜG`ۋ߅H׃qpSeRjSsBMeTlIeP_Ĝ\xWAKgGPaؔQMKNonœ}ȃԜyŌԌ嚃Ovs׋pPaU~׏rԋҗU熈LLcStOKn܇سmrR´~ZηQ\GfKVtYuX|_nx|PIIׇNzrA|̎cIXAJNEbzpo~n\[ąɐ򋘺ݏfZxeSz_}^J~HđQyDhʎnוXdvu\Ic狔fegB]Cc|늎p⚰d{ՙBlVӆbGA|ӗ]٪xـ僞^Vt呔྄fꠌ煇DgOZIZ~ӞI@ܗ~{ODE߃sblPym\C؜L[wuUMpE^SfShLTpSPwݗoxؓӇD`D񀼛EَVvԓ}wWUsM{C䓾V怲Gac䆔Rwtvk}osmؕ^ƈُԍMMbݞd]XP^^T؞ԟXVEҎw|܉ԎFQuqZ݁LЖi假^JXxnhRWR̖uQRXHϠMZtZӏȇbcoGWAԒfщĚgh߀QoJQDSem]xVxZRMdLԜCDqȝ՟Q钫@؛ZCeEIuO݋DEӋӛH^oӓԑj\K^JWbϊQVqaAvaZ⛃r{PeuOԹ{gD}OzA|캆p]b`vҊIŞTuRGV첀Yad{Yvu{\zɔqCe_UgI^׍oAY]ðXM^o\H֔MxaMGo|~NBPL@ioRdqޟÄnmfbFxe䏑քnՙZ|MeNhXQ^Hkx܊E_PNz|`DwnS~VhlHѝK~ĒyVrENkL̝hQTʉ|KHUϓϞDRهƜZ|lAn][{ڔr@@m׎[|E|hZƄڝZ焰ADICwh؂xY[vr`B˞WyߊPr]ZZOcVZ~kzɏB砑ziĘ朑ٟ`YIўcZvՏu|炿CR[CUA[_Okg`XIc|Nsgt^yw@\Ŕn]d{ɖVaǊ䓧tEVDUeNtJRB]tu̔Tꑉ]邞oO_`AFRA|n\yLD[莒݆S]Փ}_߉茻jjΫMTTHXHҿ|]VG@s`aΛRROߘqIu~}mzUM֙zN؈^TQN]VTРF{i[iҒdkJ[dtwR瑑}hQևփx{\fc{yX[tGHȔMāFf݂TB\UYbQro~ērzwSZWtIa֎YTPۘr\i`_՛h~lؚO{uHᕓ䁘Vh璗ĚRTM◉әIU_@FUwtXQ\lqLnaq`j܉Nԙ{Ijuۄ@̃SN[VSwRE`固DJHupAՈcF͐glqڅ^|xxUzEԏJb㌅so_I׌_@ʁƘgJxܐsqVϔdAܛJ͘c_SwِмR}߿Cwx|YᇄhW٠Ә~XpsxBdzOIBԖՔcKَ{ԊrgRmҕԇuPPsYB۫FRݔHgQdVplfTqpzP񆾌JZAb\˒t`}KVCqdmSqrOpSpssiÏHYB_BT؝cTՄ@gU활Ch|M{ӑwv`R}wϾYDlgfNFd N~yQ^^dDQFj͑ÓrWEXmzeBfwUWyf`HSȔξ^lՆ靜|tny键Y΁uCPn}u_oʏǉ]F`wT\^Fau㊑q]tҠrݠ{bMBrwte@UFIhWw{W\sBϖi]lԔGAJ|ʒNԇ[^t򔽋nfy{CaxCXi\dꀜPC}̓uSwmԂ܎x_kXC曌WoLԃZӖӍd_\fӠI鎟}rGV򞅘IחZ|BPꖰWBӟubG{ˎU_퓘I~v]ϟtUzxρˇ|xԄhxg[rҎFAOWOOŜay[㟰aыtΞIωAfLLMvt]uW`WѓbxԁOn]♪qT~Bݛ~OcZZzuASR՘Iʚ铋uDeOrxY@@TAhSxsS耻XyE\Nji|CysdٝڎYEKz菗؟tّKj\PٛC܈lpSֱKݚ䗣`dq~ÛwtUHN@ֆmpؑᘂ\ꇜbEFcc걠bYCՊ`P~̼S|sdTeٗv·{WUz犽KN[RaSEqUiTDTATvЙ㏌uDٍDfbyѠF٘YKPՁՎCƝYnJlwD{ObۙvuՌ|O{M@ygVOKNhյYVⷷMEFYRqӜDL}ƔETDj@vyϐ[nR[노^BI]ӅvS͚ň߈|{ȒɉOwUzjoLSewNlݝsEzfyzgRMܠ}dLl^LgbOyH{uxX[udBI[{ğMg\DEGRAXacIXxO";

            char[] sArray = s.ToCharArray();

            foreach (char c in sArray)
            {
                if (trad.IndexOf(c) >= 0)
                    sb.Append(simp.Substring(trad.IndexOf(c), 1));
                else
                    sb.Append(c);
            }
            return sb.ToString();
        }

        /*======= ICTCLAS УδõķĿǰдʵ ============
      
        //Get the max Prefix string made up of Chinese Char
        public static uint GetCCPrefix(string sSentence)
        {
           return 0;
        }

        //Judge the string is all made up of non-Chinese Char
        public static bool IsAllNonChinese(string sString)
        {
           return true;
        }

        //Judge the string is all made up of Single Byte Char
        public static bool IsAllSingleByte(string sString)
        {
           return true;
        }



        //Judge the string is all made up of Index Num Char
        public static bool IsAllIndex(string sString)
        {
           return true;
        }

        //Judge the string is all made up of Delimiter
        public static bool IsAllDelimiter(string sString)
        {
           return true;
        }

        //sWord maybe is a foreign translation
        public static bool IsForeign(string sWord)
        {
           return true;
        }

        //Decide whether the word is all  foreign translation
        public static bool IsAllForeign(string sWord)
        {
           return true;
        }

        //Return the foreign type 
        public static int GetForeignType(string sWord)
        {
           return 0;
        }

        //Get the postfix
        public static bool PostfixSplit(string sWord, string sWordRet, string sPostfix)
        {
           return true;
        }

        //Judge whether it's a num
        public static bool IsSingleByteDelimiter(char cByteChar)
        {
           return true;
        }

        ================================================================*/

    }
}